define(['dojo/_base/declare', 'jimu/BaseWidget', "dijit/_WidgetsInTemplateMixin", "jimu/dijit/FeatureSetChooserForMultipleLayers", "jimu/dijit/Message", "jimu/LayerInfos/LayerInfos", "dojo/_base/array", "dojo/_base/html", "dojo/_base/lang", "dojo/data/ObjectStore", "dojo/dom-construct", "dojo/on", "dojo/query", "dojo/store/Memory", "dgrid1/Grid", "dgrid1/extensions/SingleQuery", "dijit/form/NumberSpinner", "dijit/form/Select", "dijit/registry", "dstore/Memory", "esri/arcgis/Portal", "esri/arcgis/OAuthInfo", "esri/Color", "esri/IdentityManager", "esri/layers/FeatureLayer", "esri/layers/LabelClass", "esri/renderers/UniqueValueRenderer", "esri/symbols/SimpleFillSymbol", "esri/symbols/SimpleLineSymbol", "esri/symbols/TextSymbol", "esri/tasks/query", "jimu/dijit/LoadingShelter"], function (declare, BaseWidget, _WidgetsInTemplateMixin, FeatureSetChooserForMultipleLayers, Message, LayerInfos, array, html, lang, ObjectStore, domConstruct, on, dojoquery, oldMemory, Grid, SingleQuery, NumberSpinner, Select, registry, Memory, arcgisPortal, ArcGISOAuthInfo, Color, esriId, FeatureLayer, LabelClass, UniqueValueRenderer, SimpleFillSymbol, SimpleLineSymbol, TextSymbol, Query) {
  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  return declare([BaseWidget, _WidgetsInTemplateMixin], {

    // Custom widget code goes here

    baseClass: 'spatial-prioritization',
    _togSignin: true,
    _ownerName: null,
    _baseGridLayerName: null,
    _portal: null,
    _portalUrl: null,
    _appInfo: null,
    _gridTotals: null,
    _layerSPGrid: null,
    _SPGridUrl: null,
    _arrayPriority: null,
    _prioritizationMethod: null, // 'Priority' or 'Coin'
    _fieldPriority: null, //'Priority' or 'Coins'
    _rendererPriority: null,
    _arrayRenderers: null,
    _coinsAllocated: null,
    _maxCellSelection: null, //check for usage on this
    _maxCoinsPerCell: null,
    _coinsRemaining: null,
    _coinsSelector: null,
    _otherAttributes: null,
    _applyAllButton: null,
    _resetButton: null,

    postCreate: function postCreate() {
      this.inherited(arguments);
      this._ownerName = this.config.agolSettings.ownerName;
      this._baseGridLayerName = this.config.agolSettings.baseGrid;
      this._appInfo = this.config.agolSettings.auths;
      this._portalUrl = this.config.agolSettings.portalUrl;
      this._prioritizationMethod = this.config.prioritizationSettings.method;
      this._fieldPriority = this.config.prioritizationSettings.field;
      this._arrayPriority = this.config.prioritizationSettings.prioritizations;
      this._coinsAllocated = this.config.prioritizationSettings.allocatedCoins;
      this._maxCoinsPerCell = this.config.prioritizationSettings.maximumCoins;

      this.signIn();
    },
    applyEdits: function applyEdits(evt) {
      var _this = this;

      var buttonMessage = void 0;
      var updated = false;
      this.shelter.show();
      var features = this._layerSPGrid.getSelectedFeatures();

      if (features.length === 0) {
        this.shelter.hide();
        return;
      }
      if ((evt.target.id === "applybtn" || evt.target.id === "coinsbtn") && html.getStyle(this.btnReturnCoins, "visibility") === "visible") {
        this.shelter.hide();
        return;
      }

      var _loop = function _loop(i, len) {
        if (evt.target.id === "applybtn" || evt.target.id === "coinsbtn" || evt.target.id === "prioritybtn") {
          if (_this._prioritizationMethod === "Priority") {
            var selectedItem = _this._arrayPriority.find(function (x) {
              return x.id === _this._prioritySelector.get("value");
            });
            if (selectedItem.max > 0 && features.length + selectedItem.existing > selectedItem.max) {
              _this._showMessage(_this.nls.warningTooManyFeatures + features.length + ")!", _this.nls.youCanOnlyAssign + selectedItem.max + _this.nls.featuresToPriority + selectedItem.label);
              _this.shelter.hide();
              return {
                v: void 0
              };
            }
            features[i].attributes[_this._fieldPriority] = _this._prioritySelector.get("value");
            updated = true;
          } else {
            if (_this._coinsSelector.value < _this._coinsSelector.constraints.min || _this._coinsSelector.value > _this._coinsSelector.constraints.max) {
              _this._showMessage(_this.nls.warningOverdrawn, _this.nls.youHaveExceeded);
              _this.shelter.hide();
              return {
                v: void 0
              };
            }
            features[i].attributes[_this._fieldPriority] = _this._coinsSelector.get("value");
            updated = true;
          }
        }
        if (_this._otherAttributes !== null) {
          var buttonName = evt.target.className.split(" ")[1];
          _this._otherAttributes.forEach(lang.hitch(_this, function (setting) {
            if (evt.target.id === "applybtn" || buttonName === setting.settingName) {
              buttonMessage = setting.selectionName;
              features[i].attributes[setting.primaryField] = setting.primarySelector.get("value");
              updated = true;
              if (setting.secondaryField) {
                features[i].attributes[setting.secondaryField] = setting.secondarySelector.get("value");
                if (setting.tertiaryField) {
                  features[i].attributes[setting.tertiaryField] = setting.tertiarySelector.get("value");
                }
              }
            }
          }));
        }
      };

      for (var i = 0, len = features.length; i < len; i++) {
        var _ret = _loop(i, len);

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }

      if (!updated) {
        this._showMessage(this.nls.warning, this.nls.featuresNotUpdated);
        return;
      }

      var resultMessage = "";
      switch (evt.target.id) {
        case "applybtn":
          resultMessage = this.nls.allSelections;
          break;
        case "coinsbtn":
        case "prioritybtn":
          resultMessage = this._prioritizationMethod;
          break;
        case "":
          resultMessage = buttonMessage;
          break;
      }
      this._layerSPGrid.applyEdits(null, features, null, lang.hitch(this, function () {
        this.shelter.hide();
        this._showMessage(this.nls.appliedChanges, resultMessage + this.nls.updated);
        if (this._prioritizationMethod === "Priority") {
          this._updateGridFeatures(features);
        } else {
          this._updateCoins(features);
        }
      }, function (error) {
        this.shelter.hide();
        this._showMessage(this.nls.appliedFailed, resultMessage + this.nls.notUpdated);
        if (this._prioritizationMethod === "Priority") {
          this._updateGridFeatures(features);
        } else {
          this._updateCoins(features);
        }
      }));
    },
    returnCoins: function returnCoins() {
      this.shelter.show();
      var features = this._layerSPGrid.getSelectedFeatures();
      if (features.length === 0) {
        this.shelter.hide();
        html.setStyle(this.btnReturnCoins, "visibility", "hidden");
        return;
      }
      for (var i = 0, len = features.length; i < len; i++) {
        features[i].attributes[this._fieldPriority] = 0;
      }
      this._layerSPGrid.applyEdits(null, features, null, lang.hitch(this, function () {
        html.setStyle(this.btnReturnCoins, "visibility", "hidden");
        this._enableBtn(this.btnApplyCoins, true);
        this._enableBtn(this.btnApply, true);
        this._updateCoins(features);
        this.shelter.hide();
        this._showMessage(this.nls.appliedChanges, this.nls.coinsReturned);
      }, function (error) {
        this.shelter.hide();
        this._showMessage(this.nls.returnFailed, this.nls.coinsNotReturned);
        this._updateCoins(features);
      }));
    },
    signIn: function signIn() {
      var uA = window.navigator.userAgent,
          onlyIEorEdge = /msie\s|trident\/|edge\//i.test(uA) && !!(document.uniqueID || window.MSInputMethodContext),
          checkVersion = onlyIEorEdge && +/(edge\/|rv:|msie\s)([\d.]+)/i.exec(uA)[2] || NaN;

      if (checkVersion < 12) {
        this._showMessage(incompatibleBrowser, internetExplorer);
        return;
      }
      if (this._togSignin) {
        this._logon();
      } else {
        this._logoff();
      }
    },
    _createAdditionalSettings: function _createAdditionalSettings() {
      if (this.config.selections.length > 0) {
        this._otherAttributes = [];
        var settings = this.config.selections;
        settings.forEach(lang.hitch(this, function (setting) {
          var settingAttributes = {};
          var settingName = setting.selectionName.replace(/\s+/g, "");
          var container = domConstruct.create("div", {}, this.divSelections);
          var settingContainer = domConstruct.create("div", {}, container);
          var primaryLabel = setting.selectionName;
          if (setting.useSecondaryField) {
            primaryLabel = this.nls.primary + setting.selectionName;
          }
          //const primarySelection = domConstruct.create('div', {
          domConstruct.create("div", {
            style: "margin-top: 5px;",
            innerHTML: this.nls.selectA + primaryLabel
          }, settingContainer);
          var primarySelector = domConstruct.create("div", {}, settingContainer);
          var ps = this._createSelector(setting.selectionTable, primaryLabel, primarySelector, "Selector");
          var primaryRenderer = this._createRenderer(setting.primaryField, setting.selectionTable, null);
          this._arrayRenderers.push({
            id: primaryLabel,
            label: primaryLabel,
            renderer: primaryRenderer
          });
          settingAttributes.selectionName = setting.selectionName;
          settingAttributes.settingName = settingName;
          settingAttributes.primaryField = setting.primaryField;
          settingAttributes.primarySelector = ps;

          if (setting.useSecondaryField) {
            var innerText = setting.selectionName;
            if (setting.secondaryOption) {
              innerText += " (" + this.nls.optional + ")";
            }
            //const secondarySelection = domConstruct.create('div', {
            domConstruct.create("div", {
              style: "margin-top: 5px;",
              innerHTML: this.nls.selectA + this.nls.secondary + innerText
            }, settingContainer);
            var secondarySelector = domConstruct.create("div", {
              style: "margin-top: 5px;"
            }, settingContainer);
            var ss = this._createSelector(setting.selectionTable, this.nls.secondary + setting.selectionName, secondarySelector, "Selector");
            var secondaryRenderer = this._createRenderer(setting.secondaryField, setting.selectionTable, null);
            this._arrayRenderers.push({
              id: this.nls.secondary + setting.selectionName,
              label: this.nls.secondary + setting.selectionName,
              renderer: secondaryRenderer
            });
            settingAttributes.secondaryField = setting.secondaryField;
            settingAttributes.secondarySelector = ss;

            if (setting.useTertiaryField) {
              var _innerText = setting.selectionName;
              if (setting.tertiaryOption) {
                _innerText += " (" + this.nls.optional + ")";
              }
              //const tertiarySelection = domConstruct.create('div', {
              domConstruct.create("div", {
                style: "margin-top: 5px;",
                innerHTML: this.nls.selectA + this.nls.tertiary + _innerText
              }, settingContainer);
              var tertiarySelector = domConstruct.create("div", {}, settingContainer);
              var ts = this._createSelector(setting.selectionTable, this.nls.tertiary + setting.selectionName, tertiarySelector, "Selector");
              var tertiaryRenderer = this._createRenderer(setting.tertiaryField, setting.selectionTable, null);
              this._arrayRenderers.push({
                id: this.nls.tertiary + setting.selectionName,
                label: this.nls.tertiary + setting.selectionName,
                renderer: tertiaryRenderer
              });
              settingAttributes.tertiaryField = setting.tertiaryField;
              settingAttributes.tertiarySelector = ts;
            }
          }
          var applyButton = domConstruct.create("div", {
            class: "jimu-btn " + settingName,
            style: "margin-top: 5px; margin-bottom: 5px;",
            onclick: lang.hitch(this, function (evt) {
              this.applyEdits(evt);
            })
          }, container);
          applyButton.innerHTML = this.nls.applyOnlyBase + setting.selectionName;
          settingAttributes.button = applyButton;
          this._otherAttributes.push(settingAttributes);
        }));
        var allContainer = domConstruct.create("div", {}, this.divSelections);
        this._applyAllButton = domConstruct.create("div", {
          id: "applybtn",
          class: "jimu-btn apply",
          style: "margin-top: 10px;",
          onclick: lang.hitch(this, function (evt) {
            this.applyEdits(evt);
          })
        }, allContainer);
        this._applyAllButton.innerHTML = this.nls.applyAll;
        this._resetButton = domConstruct.create("div", {
          class: "jimu-btn",
          style: "margin-top: 10px; margin-left: 5px;",
          onclick: lang.hitch(this, function () {
            //this.resetChoices;
            dojoquery(".Selector").forEach(function (node) {
              var value = -1;
              if (registry.byNode(node).defaultSelection != undefined) {
                value = registry.byNode(node).defaultSelection;
              }
              registry.byNode(node).set("value", value);
            });
          })
        }, allContainer);
        this._resetButton.innerHTML = this.nls.resetPulldowns;

        //const rendererLabel = domConstruct.create('div', {
        domConstruct.create("div", {
          style: "margin-top: 20px;",
          innerHTML: this.nls.changeAttributeDisplay
        }, this.divSelections);
        var rendererSelector = domConstruct.create("div", {}, this.divSelections);
        var s = this._createSelector(this._arrayRenderers, this.nls.renderer, rendererSelector, "Renderer", null);
        s.on("change", lang.hitch(this, function (evt) {
          var filter = array.filter(this._arrayRenderers, function (item) {
            return item.id === evt;
          });
          this._layerSPGrid.setRenderer(filter[0].renderer);
          this._layerSPGrid.redraw();
        }));
      }
      this._initializeButtons();
    },
    _createCoinSelector: function _createCoinSelector() {
      this._coinsSelector = new NumberSpinner({
        //id: 'selectCoins',
        value: 0,
        constraints: {
          min: 0,
          max: this._maxCoinsPerCell
        },
        intermediateChanges: true,
        //disabled: true,
        style: "width: 75px"
      }, this.coinSelectionNode);
    },
    _createRenderer: function _createRenderer(field, itemArray, defaultLabel) {
      var defaultSymbol = new SimpleFillSymbol().setStyle(SimpleFillSymbol.STYLE_NULL);
      //const noneSymbol = new SimpleFillSymbol().setStyle(SimpleFillSymbol.STYLE_NULL);
      defaultSymbol.outline.setStyle(SimpleLineSymbol.STYLE_NULL);

      var renderer = new UniqueValueRenderer(defaultSymbol, field);
      for (var i = 0, len = itemArray.length; i < len; i++) {
        renderer.addValue({
          value: itemArray[i]["id"],
          symbol: new SimpleFillSymbol().setColor(new Color(itemArray[i]["color"])),
          label: itemArray[i]["label"],
          description: itemArray[i]["label"]
        });
      }
      renderer.defaultLabel = defaultLabel;
      return renderer;
    },
    _createSelectDijit: function _createSelectDijit() {
      this.selectDijit = new FeatureSetChooserForMultipleLayers({
        map: this.map,
        updateSelection: true,
        fullyWithin: false,
        geoTypes: ["POINT", "EXTENT", "POLYGON", "CIRCLE", "POLYLINE", "FREEHAND_POLYGON"]
      });
      html.place(this.selectDijit.domNode, this.selectDijitNode);
      this.selectDijit.startup();
      this.selectDijit.setFeatureLayers([this._layerSPGrid]);

      this.own(on(this.selectDijit, "user-clear", lang.hitch(this, function () {
        if (this._prioritizationMethod === "Priority") {
          this._updateGridFeatures([]);
        } else {
          this._updateCoins([]);
        }
        this._enableAllButtons(false);
        html.setStyle(this.btnReturnCoins, "visibility", "hidden");
      })));

      this.own(on(this.selectDijit, "unloading", lang.hitch(this, function () {
        var features = this._layerSPGrid.getSelectedFeatures();
        this._enableAllButtons(features.length > 0);
        if (this._prioritizationMethod === "Priority") {
          this._updateGridFeatures(features);
        } else {
          this._updateCoins(features);
        }
      })));
    },
    _createPrioritySelector: function _createPrioritySelector() {
      var store = new oldMemory({
        data: this._arrayPriority
      });
      var os = new ObjectStore({
        objectStore: store
      });
      try {
        this._prioritySelector = new Select({
          //id: 'selectPriority',
          store: os,
          required: true,
          sortByLabel: false,
          title: this.nls.priorityText,
          style: "margin-top: 5px;"
        }, this.selectPriorityNode);
        this._prioritySelector.startup();
      } catch (e) {
        console.log(e);
      }
      //this.selectPriority.set('store', os);
    },
    _createSelector: function _createSelector(data, title, node, className, defaultSelection) {
      var store = new oldMemory({
        data: data
      });
      var os = new ObjectStore({
        objectStore: store
      });
      var s = new Select({
        class: className,
        store: os,
        required: true,
        sortByLabel: false,
        title: title,
        style: "margin-top: 5px;",
        defaultSelection: defaultSelection
      }, node);
      s.startup();
      return s;
    },
    _createTotalGrid: function _createTotalGrid() {
      this._gridTotals = new (declare([Grid, SingleQuery]))({
        //id: 'gridPriority',
        columns: {
          label: {
            label: this.nls.priorityText,
            sortable: false
          },
          existing: {
            label: this.nls.current,
            sortable: false
          },
          selected: {
            label: this.nls.selected,
            sortable: false
          }
        },
        className: "dgrid-autoheight"
      });
      this._gridTotals.startup();
      html.place(this._gridTotals.domNode, this.totalGrid);
      this._updateGridFeatures([]);
    },
    _enableBtn: function _enableBtn(btn, isEnable) {
      if (btn) {
        if (isEnable) {
          html.removeClass(btn, "jimu-state-disabled");
        } else {
          html.addClass(btn, "jimu-state-disabled");
        }
      }
    },
    _enableAllButtons: function _enableAllButtons(isEnable) {
      this._enableBtn(this.btnApply, isEnable);
      this._enableBtn(this.btnApplyCoins, isEnable);
      this._enableBtn(this.btnApplyPriority, isEnable);
      if (this._otherAttributes !== null) {
        this._enableBtn(this._applyAllButton, isEnable);
        this._otherAttributes.forEach(lang.hitch(this, function (setting) {
          this._enableBtn(setting.button, isEnable);
        }));
      }
    },
    _initializeButtons: function _initializeButtons() {
      this._enableAllButtons(false);
      html.setStyle(this.btnReturnCoins, "visibility", "hidden");
    },
    _logon: function _logon() {
      var theAppId = void 0,
          thePopupCallbackUrl = void 0;

      this.btnSignIn.innerHTML = this.nls.signout;
      this._togSignin = false;

      var location = this._appInfo.find(function (x) {
        return x.location === window.location.hostname;
      });
      if (location !== undefined) {
        theAppId = location.appId;
        thePopupCallbackUrl = location.popupCallbackUrl;
      } else {
        this._showMessage(this.nls.signinError, this.nls.signinNotAllowed);
        this._logoff();
        return;
      }
      var info = new ArcGISOAuthInfo({
        appId: theAppId,
        popupCallbackUrl: thePopupCallbackUrl,
        popup: true,
        portalUrl: this._portalUrl
      });

      esriId.registerOAuthInfos([info]);
      esriId.getCredential(info.portalUrl, {
        oAuthPopupConfirmation: true
      }).then(lang.hitch(this, function () {
        this._portal = new arcgisPortal.Portal(this._portalUrl);
        this._portal.signIn().then(lang.hitch(this, function (portalUser) {
          this.welcomeNote.innerHTML = this.nls.welcome + portalUser.firstName + "!";
          var portal = portalUser.portal;
          var queryParams = {
            num: 100,
            q: "owner: " + this._ownerName + " AND type: Feature Service"
          };
          portal.queryItems(queryParams).then(lang.hitch(this, function (result) {
            if (result.total > 0) {
              if (array.some(result.results, lang.hitch(this, function (item) {
                this._SPGridUrl = item.url;
                return this._SPGridUrl.indexOf(this._baseGridLayerName) > -1; //
              }))) {
                this._prepareEditor();
              } else {
                this._SPGridUrl = null;
                this._showMessage(this.nls.loggingOut, this.nls.notAuthorized);
                this._logoff();
              }
            } else {
              this._SPGridUrl = null;
              this._showMessage(this.nls.loggingOut, this.nls.notAvailable);
              this._logoff();
            }
          }));
        })).otherwise(lang.hitch(this, function (error) {
          this._showMessage(this.nls.signinError, error);
          this._logoff();
        }));
      })).otherwise(lang.hitch(this, function (error) {
        this._showMessage(this.nls.signinError, error.message);
        this._logoff();
      }));
    },
    _logoff: function _logoff() {
      html.setStyle(this.loginNode, "display", "none");
      if (this._layerSPGrid) {
        this.map.removeLayer(this._layerSPGrid);
      }
      if (this._gridTotals) {
        this._gridTotals.destroy();
      }
      if (this.selectDijit) {
        this.selectDijit.destroy();
      }
      domConstruct.empty(this.divSelections);
      this._togSignin = true;
      this.btnSignIn.innerHTML = this.nls.signin;
      this.welcomeNote.innerHTML = "";
      if (this._portal !== null) this._portal.signOut();
    },
    _prepareEditor: function _prepareEditor() {
      this._layerSPGrid = new FeatureLayer(this._SPGridUrl + "/0", {
        outFields: ["*"],
        id: "Priority"
      });
      var label = new TextSymbol();
      label.color.setColor(new Color("black"));
      label.font.setSize("8pt");
      label.font.setFamily("arial");
      var json = {
        labelExpressionInfo: {
          value: "{" + this._fieldPriority + "}"
        }
      };
      var labelClass = new LabelClass(json);
      labelClass.symbol = label;
      this._layerSPGrid.setLabelingInfo([labelClass]);

      //create renderers individually as needed
      this._rendererPriority = this._createRenderer(this._fieldPriority, this._arrayPriority, " ");
      this._layerSPGrid.setRenderer(this._rendererPriority);
      if (this.config.filter) {
        this._layerSPGrid.setDefinitionExpression(this.config.filter.expr);
      }
      this.map.addLayer(this._layerSPGrid);

      this._arrayRenderers = [];
      this._arrayRenderers.push({
        id: "Priority",
        label: this.nls.priorityText,
        renderer: this._rendererPriority
      });
      this._createAdditionalSettings();

      this._layerSPGrid.on("load", lang.hitch(this, function () {
        this._createSelectDijit();
        if (!this._layerSPGrid.isEditable()) {
          this._showMessage(this.nls.warning, this.nls.notEditable);
        }
        if (this._prioritizationMethod === "Priority") {
          html.setStyle(this.divHigh, "display", "block");
          this._createPrioritySelector();
          this._createTotalGrid();
        } else {
          html.setStyle(this.divCoins, "display", "block");
          this._createCoinSelector();
          this._updateCoins([]);
        }
        html.setStyle(this.loginNode, "display", "block");

        LayerInfos.getInstance(this.map, this.map.itemInfo).then(lang.hitch(this, function (layerInfos) {
          var featureLayerInfo = layerInfos.getLayerInfoById(this._layerSPGrid.id);
          featureLayerInfo.loadInfoTemplate().then(lang.hitch(this, function () {
            featureLayerInfo.enablePopup();
          }));
        }));
        html.setStyle(this.loginNode, "display", "block");
      }));
    },
    _showMessage: function _showMessage(title, message) {
      new Message({
        titleLabel: title,
        message: message
      });
    },
    _updateCoins: function _updateCoins(selectedFeatures) {
      var query = new Query();
      query.where = "1=1";
      query.outFields = ["*"];
      this.shelter.show();
      this._layerSPGrid.queryFeatures(query, lang.hitch(this, function (featureSet) {
        var features = featureSet.features;
        var assigned = 0;
        features.forEach(lang.hitch(this, function (feature) {
          assigned += feature.attributes[this._fieldPriority];
        }));
        var selectedCount = 0;
        selectedFeatures.forEach(lang.hitch(this, function (feature) {
          selectedCount += feature.attributes[this._fieldPriority];
        }));
        this._coinsRemaining = this._coinsAllocated - assigned;

        if (selectedFeatures.length > 0 && selectedCount > 0) {
          this.coinAllocatedNode.innerHTML = this.nls.coinsAssigned + assigned + " (" + selectedCount + this.nls.selectedNote;
          if (selectedCount > 0) {
            this._enableBtn(this.btnApplyCoins, false);
            this._enableBtn(this.btnApply, false);
            if (this._layerSPGrid.isEditable()) {
              html.setStyle(this.btnReturnCoins, "visibility", "visible");
              if (this._applyAllButton != null) {
                this._enableBtn(this._applyAllButton, false);
              }
            }
          }
        } else {
          this.coinAllocatedNode.innerHTML = this.nls.coinsAssigned + assigned;
        }
        this.coinAvailableNode.innerHTML = this.nls.coinsAvailable + this._coinsRemaining;
        this.cellSelectedNode.innerHTML = this.nls.coinsSelected + selectedFeatures.length;
        if (selectedFeatures.length > this._coinsRemaining + selectedCount) {
          this._coinsSelector.constraints.max = 0;
        } else {
          this._coinsSelector.constraints.max = (this._coinsRemaining + selectedCount) / selectedFeatures.length > this._maxCoinsPerCell ? this._maxCoinsPerCell : Math.floor((this._coinsRemaining + selectedCount) / selectedFeatures.length);
        }
        this._coinsSelector.set("value", this._coinsSelector.constraints.max);
        if (selectedCount === 0) {
          html.setStyle(this.btnReturnCoins, "visibility", "hidden");
          if (this._applyAllButton != null) {
            this._enableBtn(this._applyAllButton, true);
          }
        }
        this.shelter.hide();
      }));
    },
    _updateGridFeatures: function _updateGridFeatures(selectedFeatures) {
      var arrTotal = [],
          arrSelected = [];

      for (var i = 0, len = this._arrayPriority.length; i < len; i++) {
        arrTotal.push(0);
        arrSelected.push(0);
      }

      for (var _i = 0, _len = selectedFeatures.length; _i < _len; _i++) {
        var feature = selectedFeatures[_i];
        for (var j = 0, len1 = this._arrayPriority.length; j < len1; j++) {
          if (feature.attributes[this._fieldPriority] === this._arrayPriority[j]["id"]) {
            arrSelected[j] = arrSelected[j] + 1;
          }
        }
      }

      var query = new Query();
      query.where = "1=1";
      query.outFields = ["*"];
      query.returnGeometry = false;
      this.shelter.show();
      this._layerSPGrid.queryFeatures(query, lang.hitch(this, function (featureSet) {
        var features = featureSet.features;
        for (var _i2 = 0, _len2 = features.length; _i2 < _len2; _i2++) {
          var _feature = features[_i2];
          for (var _j = 0, _len3 = this._arrayPriority.length; _j < _len3; _j++) {
            var test = _feature.attributes[this._fieldPriority];
            var test1 = this._arrayPriority[_j]["id"];
            if (_feature.attributes[this._fieldPriority] === this._arrayPriority[_j]["id"]) {
              arrTotal[_j] = arrTotal[_j] + 1;
            }
          }
        }

        var arrPriority = this._arrayPriority.slice();
        for (var _i3 = 0, _len4 = this._arrayPriority.length; _i3 < _len4; _i3++) {
          arrPriority[_i3].existing = arrTotal[_i3];
          arrPriority[_i3].selected = arrSelected[_i3];
        }
        arrPriority.push({
          id: this._arrayPriority.length,
          label: this.nls.total,
          existing: features.length,
          selected: selectedFeatures.length
        });

        var store = new Memory({
          data: arrPriority
        });
        this._gridTotals.set("collection", store);
        this._gridTotals.resize();
        this.shelter.hide();
      }));
    }
  });
});
//# sourceMappingURL=Widget.js.map
